#include "HParaModel.h"

#include "stdafx.h"
#include "string.h"
#include "htools.h"
#include "hc.h"

#include "parasolid_kernel.h"
#include "kernel_interface.h"
#include "hp_bridge.h"


HParaModel::HParaModel(HDB* hDB) : HBaseModel(hDB)
{
	type = 0;

	HC_Open_Segment_By_Key(m_ModelKey);	
	  m_parts_seg = HC_KCreate_Segment("");
	HC_Close_Segment();

}


// our application-specific read function
int HParaModel::Read(const char * FileName) 
{   
	char extension[120]; 

	unsigned long length;
	auto	HKEY 		app_name;
	auto	DWORD		type;
    auto	char 		return_string[2048];
	char *SchemaPath;
	
	if (RegOpenKeyEx (HKEY_CURRENT_USER, "HOOPS", 0L,
			  KEY_QUERY_VALUE, &app_name) != ERROR_SUCCESS)
	    length = 0; /* Explicit failure */
	else
	{
		length = sizeof (return_string);
		if (RegQueryValueEx (app_name, "PARASOLID_SCHEMA_PATH", NULL, &type,
				 (LPBYTE)return_string,
				 &length) != ERROR_SUCCESS)
			length = 0;	/* Explicit Failure */
	}
	RegCloseKey (app_name);

	if (length > 0)
		SchemaPath = return_string;
	else
	{
		SchemaPath = "\\hoops\\parasolid\\schema";
	}


	// read the file into the model object's model segment
    HC_Open_Segment_By_Key(m_ModelKey);	
        extension[0]=0;
        HC_Parse_String(FileName,".",-1,extension);
        strlwr(extension);
		if  (streq(extension,"xmt_txt") || streq(extension,"x_t")) {  
			HP_Read_Xmt_File(FileName, SchemaPath);	// read an XMT file
		} 
		else
        {
			HBaseModel::Read(FileName);				// call base to read HMF, etc...
			type = 1;
        }

    HC_Close_Segment();

    return(0);
}